/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"context"
	"time"

	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	scheme "quark.netapp.io/volume-controller/pkg/client/clientset/versioned/scheme"
)

// NetAppObjectStoresGetter has a method to return a NetAppObjectStoreInterface.
// A group's client should implement this interface.
type NetAppObjectStoresGetter interface {
	NetAppObjectStores(namespace string) NetAppObjectStoreInterface
}

// NetAppObjectStoreInterface has methods to work with NetAppObjectStore resources.
type NetAppObjectStoreInterface interface {
	Create(ctx context.Context, netAppObjectStore *v1alpha1.NetAppObjectStore, opts v1.CreateOptions) (*v1alpha1.NetAppObjectStore, error)
	Update(ctx context.Context, netAppObjectStore *v1alpha1.NetAppObjectStore, opts v1.UpdateOptions) (*v1alpha1.NetAppObjectStore, error)
	UpdateStatus(ctx context.Context, netAppObjectStore *v1alpha1.NetAppObjectStore, opts v1.UpdateOptions) (*v1alpha1.NetAppObjectStore, error)
	Delete(ctx context.Context, name string, opts v1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error
	Get(ctx context.Context, name string, opts v1.GetOptions) (*v1alpha1.NetAppObjectStore, error)
	List(ctx context.Context, opts v1.ListOptions) (*v1alpha1.NetAppObjectStoreList, error)
	Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppObjectStore, err error)
	NetAppObjectStoreExpansion
}

// netAppObjectStores implements NetAppObjectStoreInterface
type netAppObjectStores struct {
	client rest.Interface
	ns     string
}

// newNetAppObjectStores returns a NetAppObjectStores
func newNetAppObjectStores(c *QuarkV1alpha1Client, namespace string) *netAppObjectStores {
	return &netAppObjectStores{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the netAppObjectStore, and returns the corresponding netAppObjectStore object, and an error if there is any.
func (c *netAppObjectStores) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1alpha1.NetAppObjectStore, err error) {
	result = &v1alpha1.NetAppObjectStore{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappobjectstores").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of NetAppObjectStores that match those selectors.
func (c *netAppObjectStores) List(ctx context.Context, opts v1.ListOptions) (result *v1alpha1.NetAppObjectStoreList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1alpha1.NetAppObjectStoreList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("netappobjectstores").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do(ctx).
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested netAppObjectStores.
func (c *netAppObjectStores) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("netappobjectstores").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch(ctx)
}

// Create takes the representation of a netAppObjectStore and creates it.  Returns the server's representation of the netAppObjectStore, and an error, if there is any.
func (c *netAppObjectStores) Create(ctx context.Context, netAppObjectStore *v1alpha1.NetAppObjectStore, opts v1.CreateOptions) (result *v1alpha1.NetAppObjectStore, err error) {
	result = &v1alpha1.NetAppObjectStore{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("netappobjectstores").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppObjectStore).
		Do(ctx).
		Into(result)
	return
}

// Update takes the representation of a netAppObjectStore and updates it. Returns the server's representation of the netAppObjectStore, and an error, if there is any.
func (c *netAppObjectStores) Update(ctx context.Context, netAppObjectStore *v1alpha1.NetAppObjectStore, opts v1.UpdateOptions) (result *v1alpha1.NetAppObjectStore, err error) {
	result = &v1alpha1.NetAppObjectStore{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("netappobjectstores").
		Name(netAppObjectStore.Name).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppObjectStore).
		Do(ctx).
		Into(result)
	return
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *netAppObjectStores) UpdateStatus(ctx context.Context, netAppObjectStore *v1alpha1.NetAppObjectStore, opts v1.UpdateOptions) (result *v1alpha1.NetAppObjectStore, err error) {
	result = &v1alpha1.NetAppObjectStore{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("netappobjectstores").
		Name(netAppObjectStore.Name).
		SubResource("status").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(netAppObjectStore).
		Do(ctx).
		Into(result)
	return
}

// Delete takes name of the netAppObjectStore and deletes it. Returns an error if one occurs.
func (c *netAppObjectStores) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappobjectstores").
		Name(name).
		Body(&opts).
		Do(ctx).
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *netAppObjectStores) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	var timeout time.Duration
	if listOpts.TimeoutSeconds != nil {
		timeout = time.Duration(*listOpts.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("netappobjectstores").
		VersionedParams(&listOpts, scheme.ParameterCodec).
		Timeout(timeout).
		Body(&opts).
		Do(ctx).
		Error()
}

// Patch applies the patch and returns the patched netAppObjectStore.
func (c *netAppObjectStores) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1alpha1.NetAppObjectStore, err error) {
	result = &v1alpha1.NetAppObjectStore{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("netappobjectstores").
		Name(name).
		SubResource(subresources...).
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(data).
		Do(ctx).
		Into(result)
	return
}
