/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by client-gen. DO NOT EDIT.

package v1alpha1

import (
	"net/http"

	rest "k8s.io/client-go/rest"
	v1alpha1 "quark.netapp.io/volume-controller/pkg/apis/volumecontroller/v1alpha1"
	"quark.netapp.io/volume-controller/pkg/client/clientset/versioned/scheme"
)

type QuarkV1alpha1Interface interface {
	RESTClient() rest.Interface
	NetAppClusterPeeringsGetter
	NetAppExportPoliciesGetter
	NetAppObjectStoresGetter
	NetAppServiceLevelsGetter
	NetAppSnapshotPoliciesGetter
	NetAppStoragePoolsGetter
	NetAppVolumesGetter
	NetAppVolumeCloudSnapshotsGetter
	NetAppVolumeReplicationsGetter
	NetAppVolumeSnapshotsGetter
	NetAppVolumeSnapshotsListsGetter
	NetAppVolumeUsagesGetter
	NodevolSetsGetter
	QuarksGetter
}

// QuarkV1alpha1Client is used to interact with features provided by the quark.netapp.io group.
type QuarkV1alpha1Client struct {
	restClient rest.Interface
}

func (c *QuarkV1alpha1Client) NetAppClusterPeerings(namespace string) NetAppClusterPeeringInterface {
	return newNetAppClusterPeerings(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppExportPolicies(namespace string) NetAppExportPolicyInterface {
	return newNetAppExportPolicies(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppObjectStores(namespace string) NetAppObjectStoreInterface {
	return newNetAppObjectStores(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppServiceLevels(namespace string) NetAppServiceLevelInterface {
	return newNetAppServiceLevels(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppSnapshotPolicies(namespace string) NetAppSnapshotPolicyInterface {
	return newNetAppSnapshotPolicies(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppStoragePools(namespace string) NetAppStoragePoolInterface {
	return newNetAppStoragePools(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppVolumes(namespace string) NetAppVolumeInterface {
	return newNetAppVolumes(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppVolumeCloudSnapshots(namespace string) NetAppVolumeCloudSnapshotInterface {
	return newNetAppVolumeCloudSnapshots(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppVolumeReplications(namespace string) NetAppVolumeReplicationInterface {
	return newNetAppVolumeReplications(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppVolumeSnapshots(namespace string) NetAppVolumeSnapshotInterface {
	return newNetAppVolumeSnapshots(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppVolumeSnapshotsLists(namespace string) NetAppVolumeSnapshotsListInterface {
	return newNetAppVolumeSnapshotsLists(c, namespace)
}

func (c *QuarkV1alpha1Client) NetAppVolumeUsages(namespace string) NetAppVolumeUsageInterface {
	return newNetAppVolumeUsages(c, namespace)
}

func (c *QuarkV1alpha1Client) NodevolSets(namespace string) NodevolSetInterface {
	return newNodevolSets(c, namespace)
}

func (c *QuarkV1alpha1Client) Quarks(namespace string) QuarkInterface {
	return newQuarks(c, namespace)
}

// NewForConfig creates a new QuarkV1alpha1Client for the given config.
// NewForConfig is equivalent to NewForConfigAndClient(c, httpClient),
// where httpClient was generated with rest.HTTPClientFor(c).
func NewForConfig(c *rest.Config) (*QuarkV1alpha1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	httpClient, err := rest.HTTPClientFor(&config)
	if err != nil {
		return nil, err
	}
	return NewForConfigAndClient(&config, httpClient)
}

// NewForConfigAndClient creates a new QuarkV1alpha1Client for the given config and http client.
// Note the http client provided takes precedence over the configured transport values.
func NewForConfigAndClient(c *rest.Config, h *http.Client) (*QuarkV1alpha1Client, error) {
	config := *c
	if err := setConfigDefaults(&config); err != nil {
		return nil, err
	}
	client, err := rest.RESTClientForConfigAndClient(&config, h)
	if err != nil {
		return nil, err
	}
	return &QuarkV1alpha1Client{client}, nil
}

// NewForConfigOrDie creates a new QuarkV1alpha1Client for the given config and
// panics if there is an error in the config.
func NewForConfigOrDie(c *rest.Config) *QuarkV1alpha1Client {
	client, err := NewForConfig(c)
	if err != nil {
		panic(err)
	}
	return client
}

// New creates a new QuarkV1alpha1Client for the given RESTClient.
func New(c rest.Interface) *QuarkV1alpha1Client {
	return &QuarkV1alpha1Client{c}
}

func setConfigDefaults(config *rest.Config) error {
	gv := v1alpha1.SchemeGroupVersion
	config.GroupVersion = &gv
	config.APIPath = "/apis"
	config.NegotiatedSerializer = scheme.Codecs.WithoutConversion()

	if config.UserAgent == "" {
		config.UserAgent = rest.DefaultKubernetesUserAgent()
	}

	return nil
}

// RESTClient returns a RESTClient that is used to communicate
// with API server by this client implementation.
func (c *QuarkV1alpha1Client) RESTClient() rest.Interface {
	if c == nil {
		return nil
	}
	return c.restClient
}
