/*
 *  Copyright (c) 2020-current NetApp
 *  All rights reserved
 */

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	internalinterfaces "quark.netapp.io/volume-controller/pkg/client/informers/externalversions/internalinterfaces"
)

// Interface provides access to all the informers in this group version.
type Interface interface {
	// NetAppClusterPeerings returns a NetAppClusterPeeringInformer.
	NetAppClusterPeerings() NetAppClusterPeeringInformer
	// NetAppExportPolicies returns a NetAppExportPolicyInformer.
	NetAppExportPolicies() NetAppExportPolicyInformer
	// NetAppObjectStores returns a NetAppObjectStoreInformer.
	NetAppObjectStores() NetAppObjectStoreInformer
	// NetAppServiceLevels returns a NetAppServiceLevelInformer.
	NetAppServiceLevels() NetAppServiceLevelInformer
	// NetAppSnapshotPolicies returns a NetAppSnapshotPolicyInformer.
	NetAppSnapshotPolicies() NetAppSnapshotPolicyInformer
	// NetAppStoragePools returns a NetAppStoragePoolInformer.
	NetAppStoragePools() NetAppStoragePoolInformer
	// NetAppVolumes returns a NetAppVolumeInformer.
	NetAppVolumes() NetAppVolumeInformer
	// NetAppVolumeCloudSnapshots returns a NetAppVolumeCloudSnapshotInformer.
	NetAppVolumeCloudSnapshots() NetAppVolumeCloudSnapshotInformer
	// NetAppVolumeReplications returns a NetAppVolumeReplicationInformer.
	NetAppVolumeReplications() NetAppVolumeReplicationInformer
	// NetAppVolumeSnapshots returns a NetAppVolumeSnapshotInformer.
	NetAppVolumeSnapshots() NetAppVolumeSnapshotInformer
	// NetAppVolumeSnapshotsLists returns a NetAppVolumeSnapshotsListInformer.
	NetAppVolumeSnapshotsLists() NetAppVolumeSnapshotsListInformer
	// NetAppVolumeUsages returns a NetAppVolumeUsageInformer.
	NetAppVolumeUsages() NetAppVolumeUsageInformer
	// NodevolSets returns a NodevolSetInformer.
	NodevolSets() NodevolSetInformer
	// Quarks returns a QuarkInformer.
	Quarks() QuarkInformer
}

type version struct {
	factory          internalinterfaces.SharedInformerFactory
	namespace        string
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// New returns a new Interface.
func New(f internalinterfaces.SharedInformerFactory, namespace string, tweakListOptions internalinterfaces.TweakListOptionsFunc) Interface {
	return &version{factory: f, namespace: namespace, tweakListOptions: tweakListOptions}
}

// NetAppClusterPeerings returns a NetAppClusterPeeringInformer.
func (v *version) NetAppClusterPeerings() NetAppClusterPeeringInformer {
	return &netAppClusterPeeringInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppExportPolicies returns a NetAppExportPolicyInformer.
func (v *version) NetAppExportPolicies() NetAppExportPolicyInformer {
	return &netAppExportPolicyInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppObjectStores returns a NetAppObjectStoreInformer.
func (v *version) NetAppObjectStores() NetAppObjectStoreInformer {
	return &netAppObjectStoreInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppServiceLevels returns a NetAppServiceLevelInformer.
func (v *version) NetAppServiceLevels() NetAppServiceLevelInformer {
	return &netAppServiceLevelInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppSnapshotPolicies returns a NetAppSnapshotPolicyInformer.
func (v *version) NetAppSnapshotPolicies() NetAppSnapshotPolicyInformer {
	return &netAppSnapshotPolicyInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppStoragePools returns a NetAppStoragePoolInformer.
func (v *version) NetAppStoragePools() NetAppStoragePoolInformer {
	return &netAppStoragePoolInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppVolumes returns a NetAppVolumeInformer.
func (v *version) NetAppVolumes() NetAppVolumeInformer {
	return &netAppVolumeInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppVolumeCloudSnapshots returns a NetAppVolumeCloudSnapshotInformer.
func (v *version) NetAppVolumeCloudSnapshots() NetAppVolumeCloudSnapshotInformer {
	return &netAppVolumeCloudSnapshotInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppVolumeReplications returns a NetAppVolumeReplicationInformer.
func (v *version) NetAppVolumeReplications() NetAppVolumeReplicationInformer {
	return &netAppVolumeReplicationInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppVolumeSnapshots returns a NetAppVolumeSnapshotInformer.
func (v *version) NetAppVolumeSnapshots() NetAppVolumeSnapshotInformer {
	return &netAppVolumeSnapshotInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppVolumeSnapshotsLists returns a NetAppVolumeSnapshotsListInformer.
func (v *version) NetAppVolumeSnapshotsLists() NetAppVolumeSnapshotsListInformer {
	return &netAppVolumeSnapshotsListInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NetAppVolumeUsages returns a NetAppVolumeUsageInformer.
func (v *version) NetAppVolumeUsages() NetAppVolumeUsageInformer {
	return &netAppVolumeUsageInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// NodevolSets returns a NodevolSetInformer.
func (v *version) NodevolSets() NodevolSetInformer {
	return &nodevolSetInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}

// Quarks returns a QuarkInformer.
func (v *version) Quarks() QuarkInformer {
	return &quarkInformer{factory: v.factory, namespace: v.namespace, tweakListOptions: v.tweakListOptions}
}
